<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>
  <body>
    <div class="container">
      <h2 style="text-align: center">Danh sách người dùng</h2>
      <table id="user-table" class="table tale- table-striped table-hover">
        <thead>
          <tr>
            <th>mã người dùng</th>
            <th>firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
    <script>
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: "GET",
        dataType: "json",
        success: function (responseObj) {
          console.log(Object.entries(responseObj));
          //xử lý out put ở đây hay gọi ra function khác
        },
        error: function (error) {
          console.assert(error.responseText);
        },
      });

      $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gDATA_COLUMN = [
          "id",
          "firstname",
          "lastname",
          "country",
          "subject",
          "customerType",
          "registerStatus",
          "action",
        ];
        const gUSE_ID = 0;
        const gFIRST_NAME = 1;
        const gLAST_NAME = 2;
        const gCOUNTRY = 3;
        const gSUBJECT = 4;
        const gCUSTOMER_TYPE = 5;
        const gREGISTER_STATUS = 6;
        const gACTION = 7;

        $("#user-table").DataTable({
          "columns": [
            { data: gDATA_COLUMN[gUSE_ID] },
            { data: gDATA_COLUMN[gFIRST_NAME] },
            { data: gDATA_COLUMN[gLAST_NAME] },
            { data: gDATA_COLUMN[gCOUNTRY] },
            { data: gDATA_COLUMN[gSUBJECT] },
            { data: gDATA_COLUMN[gCUSTOMER_TYPE] },
            { data: gDATA_COLUMN[gREGISTER_STATUS] },
            { data: gDATA_COLUMN[gACTION] },
          ],
          columnDefs: [
            {
              targets: gACTION,
              defaultContent:
                '<button class="btn btn-success btn-detail">chi tiết</button>', // nội dụng html của cột là nút button class btn-detail để đánh dấu nút hiện information
            },
          ],
        });
        onPageLoading();
        $(document).on("click", "#user-table .btn-detail", function () {
          onBtnDetailClick(this);
        });
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        //hàm được gọi load trang
        function onPageLoading() {
          "use strict";
          $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
            type: "GET",
            dataType: "json",
            success: function (paramObject) {
              debugger;
              loadDataToTable(paramObject);
            },
            error: function (ajaxContent) {
              alert(ajaxContent.responseText);
            },
          });
        }
        function loadDataToTable(paramObjUser){
            "use strict"
            var vTable  =$("#user-table").DataTable()
            vTable.clear();
            vTable.rows.add(paramObjUser)
            vTable.draw();
        }
        function onBtnDetailClick(paramEle){
            "use strict"
            var vRowClick = $(paramEle).parents("tr");
            var vTable = $("#user-table").DataTable();
            vDatarow =vTable.row(vRowClick).data()
            console.log("user id: "+ vDatarow.id);
            console.log("first name : "+ vDatarow.firstname);
            console.log("last name: "+ vDatarow.lastname);
            console.log("user country: "+ vDatarow.country);
            console.log("user subject: "+ vDatarow.subject);
            console.log("user customer type: "+ vDatarow.customerType);
            console.log("user register status: "+ vDatarow.registerStatus);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      });
    </script>
  </body>
</html>
